"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.oauth2Signer = oauth2Signer;
exports.githubOAuth2 = githubOAuth2;
var tslib_1 = require("tslib");
var web_utility_1 = require("web-utility");
var DOMAIN = process.env.VERCEL_PROJECT_PRODUCTION_URL;
var Host = DOMAIN ? "https://".concat(DOMAIN) : 'http://localhost:3000';
function oauth2Signer(_a) {
    var _this = this;
    var signInURL = _a.signInURL, accessToken = _a.accessToken, userProfile = _a.userProfile, _b = _a.tokenKey, tokenKey = _b === void 0 ? 'token' : _b;
    return function (_a, next_1) { return tslib_1.__awaiter(_this, [_a, next_1], void 0, function (_b, next) {
        var token, pageURL, token_1, searchParams, user, data, props;
        var _c = _b.req, url = _c.url, headers = _c.headers, query = _b.query;
        return tslib_1.__generator(this, function (_d) {
            switch (_d.label) {
                case 0:
                    token = query[tokenKey];
                    pageURL = new URL(url || '/', headers['origin'] || Host);
                    if (!query.code) return [3 /*break*/, 2];
                    return [4 /*yield*/, accessToken(query)];
                case 1:
                    token_1 = _d.sent(), searchParams = pageURL.searchParams;
                    searchParams.set(tokenKey, token_1);
                    searchParams.delete('code');
                    if (searchParams.get('state') === '')
                        searchParams.delete('state');
                    return [2 /*return*/, {
                            redirect: { destination: pageURL + '', permanent: false },
                            props: {}
                        }];
                case 2:
                    if (!token) return [3 /*break*/, 5];
                    return [4 /*yield*/, userProfile(token + '')];
                case 3:
                    user = _d.sent();
                    return [4 /*yield*/, next()];
                case 4:
                    data = _d.sent();
                    props = 'props' in data ? tslib_1.__assign(tslib_1.__assign({}, data.props), { token: token, user: user }) : {};
                    return [2 /*return*/, tslib_1.__assign(tslib_1.__assign({}, data), { props: props })];
                case 5: return [2 /*return*/, {
                        redirect: {
                            destination: signInURL(pageURL + ''),
                            permanent: false
                        },
                        props: {}
                    }];
            }
        });
    }); };
}
function githubOAuth2(_a) {
    var _this = this;
    var _b = _a.rootBaseURL, rootBaseURL = _b === void 0 ? 'https://github.com' : _b, _c = _a.apiBaseURL, apiBaseURL = _c === void 0 ? 'https://api.github.com' : _c, client_id = _a.client_id, client_secret = _a.client_secret, scopes = _a.scopes, _d = _a.allow_signup, allow_signup = _d === void 0 ? true : _d;
    return oauth2Signer({
        signInURL: function (redirect_uri) {
            return "https://github.com/login/oauth/authorize?".concat((0, web_utility_1.buildURLData)({
                client_id: client_id,
                scope: scopes === null || scopes === void 0 ? void 0 : scopes.join(' '),
                allow_signup: allow_signup,
                redirect_uri: redirect_uri
            }));
        },
        accessToken: function (_a) { return tslib_1.__awaiter(_this, [_a], void 0, function (_b) {
            var response, _c, error, access_token;
            var code = _b.code;
            return tslib_1.__generator(this, function (_d) {
                switch (_d.label) {
                    case 0: return [4 /*yield*/, fetch(new URL('login/oauth/access_token', rootBaseURL), {
                            method: 'POST',
                            headers: {
                                Accept: 'application/json',
                                'Content-Type': 'application/json'
                            },
                            body: JSON.stringify({ client_id: client_id, client_secret: client_secret, code: code })
                        })];
                    case 1:
                        response = _d.sent();
                        return [4 /*yield*/, response.json()];
                    case 2:
                        _c = _d.sent(), error = _c.error, access_token = _c.access_token;
                        if (error)
                            throw new URIError(error);
                        return [2 /*return*/, access_token];
                }
            });
        }); },
        userProfile: function (token) { return tslib_1.__awaiter(_this, void 0, void 0, function () {
            var response;
            return tslib_1.__generator(this, function (_a) {
                switch (_a.label) {
                    case 0: return [4 /*yield*/, fetch(new URL('user', apiBaseURL), {
                            headers: {
                                Authorization: "Bearer ".concat(token),
                                Accept: 'application/json'
                            }
                        })];
                    case 1:
                        response = _a.sent();
                        if (response.status < 300)
                            return [2 /*return*/, response.json()];
                        throw new URIError('Invalid GitHub access token');
                }
            });
        }); }
    });
}
//# sourceMappingURL=remote.js.map