import { NextRequest } from 'next/server';
import { GetServerSideProps } from 'next/types';
import { ParsedUrlQuery } from 'querystring';
import type { ReactNode } from 'react';
/**
 * @see {@link https://www.propelauth.com/post/getting-url-in-next-server-components}
 */
export declare function patchHeaders(request: NextRequest): Headers;
export type ServerProps<I extends Record<string, string> = {}, O extends object = {}> = O & {
    params: Promise<I>;
    searchParams: Promise<ParsedUrlQuery>;
};
export type ServerComponent<I extends Record<string, string> = {}, O extends object = {}> = (props: ServerProps<I, O>) => Promise<ReactNode>;
export declare const withMiddleware: <I extends Record<string, string> = {}, O extends object = {}>(getServerSideProps: GetServerSideProps<O, I>, serverComponent: ServerComponent<I, O>) => ServerComponent<I>;
